Index: uspace/lib/posix/source/stdlib/strtold.c
===================================================================
--- uspace/lib/posix/source/stdlib/strtold.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/posix/source/stdlib/strtold.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -35,6 +35,8 @@
 #define LIBPOSIX_INTERNAL
 
+/* Must be first. */
+#include "posix/stdbool.h"
+
 #include "../internal/common.h"
-#include "libc/stdbool.h"
 #include "posix/stdlib.h"
 
Index: uspace/lib/posix/source/time.c
===================================================================
--- uspace/lib/posix/source/time.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/posix/source/time.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,4 +36,7 @@
 #define LIBPOSIX_INTERNAL
 
+/* Must be first. */
+#include "posix/stdbool.h"
+
 #include "internal/common.h"
 #include "posix/time.h"
@@ -47,5 +50,4 @@
 #include "libc/task.h"
 #include "libc/stats.h"
-#include "libc/stdbool.h"
 #include "libc/sys/time.h"
 
Index: uspace/lib/softfloat/common.c
===================================================================
--- uspace/lib/softfloat/common.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/softfloat/common.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -39,5 +39,5 @@
 /* Table for fast leading zeroes counting. */
 char zeroTable[256] = {
-	8, 7, 6, 6, 5, 5, 5, 5, 4, 4, 4, 4, 4, 4, 4, 4, \
+	8, 7, 7, 6, 6, 6, 6, 4, 4, 4, 4, 4, 4, 4, 4, \
 	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, \
 	2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, \
@@ -307,24 +307,16 @@
 /**
  * Round and normalize number expressed by exponent and fraction with
- * first bit (equal to hidden bit) at bit 62.
+ * first bit (equal to hidden bit) at 62nd bit.
  *
  * @param exp Exponent part.
- * @param fraction Fraction with hidden bit shifted to bit 62.
+ * @param fraction Fraction with hidden bit shifted to 62nd bit.
  */
 void round_float64(int32_t *exp, uint64_t *fraction)
 {
-	/*
-	 * Rounding - if first bit after fraction is set then round up.
-	 */
-
-	/*
-	 * Add 1 to the least significant bit of the fraction respecting the
-	 * current shift to bit 62 and see if there will be a carry to bit 63.
-	 */
+	/* rounding - if first bit after fraction is set then round up */
 	(*fraction) += (0x1 << (64 - FLOAT64_FRACTION_SIZE - 3));
 	
-	/* See if there was a carry to bit 63. */
 	if ((*fraction) & 
-	    (FLOAT64_HIDDEN_BIT_MASK << (64 - FLOAT64_FRACTION_SIZE - 1))) {
+	    (FLOAT64_HIDDEN_BIT_MASK << (64 - FLOAT64_FRACTION_SIZE - 3))) {
 		/* rounding overflow */
 		++(*exp);
Index: uspace/lib/softrend/filter.c
===================================================================
--- uspace/lib/softrend/filter.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/softrend/filter.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -44,4 +44,6 @@
 		_x %= pixmap->width;
 		_y %= pixmap->height;
+	} else if (_x < 0 || _x >= (long) pixmap->width || _y < 0 || _y >= (long) pixmap->height) {
+		return 0;
 	}
 
Index: uspace/lib/softrend/filter.h
===================================================================
--- uspace/lib/softrend/filter.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/softrend/filter.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,5 +37,5 @@
 #define SOFTREND_FILTER_H_
 
-#include <stdbool.h>
+#include <bool.h>
 #include <io/pixelmap.h>
 
Index: uspace/lib/softrend/pixconv.h
===================================================================
--- uspace/lib/softrend/pixconv.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/softrend/pixconv.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,5 +38,5 @@
 #define SOFTREND_PIXCONV_H_
 
-#include <stdbool.h>
+#include <bool.h>
 #include <io/pixel.h>
 
Index: uspace/lib/softrend/rectangle.h
===================================================================
--- uspace/lib/softrend/rectangle.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/softrend/rectangle.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,5 +38,5 @@
 
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 
 extern bool rectangle_intersect(
Index: uspace/lib/softrend/transform.c
===================================================================
--- uspace/lib/softrend/transform.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/softrend/transform.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -136,12 +136,4 @@
 }
 
-bool transform_is_fast(transform_t *t)
-{
-	return (t->m[0][0] == 1) && (t->m[0][1] == 0)
-	    && (t->m[1][0] == 0) && (t->m[1][1] == 1)
-	    && ((t->m[0][2] - ((long) t->m[0][2])) == 0.0)
-	    && ((t->m[1][2] - ((long) t->m[1][2])) == 0.0);
-}
-
 void transform_apply_linear(const transform_t *t, double *x, double *y)
 {
Index: uspace/lib/softrend/transform.h
===================================================================
--- uspace/lib/softrend/transform.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/softrend/transform.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,6 +37,4 @@
 #define SOFTREND_TRANSFORM_H_
 
-#include <stdbool.h>
-
 #ifndef PI
 #define PI 3.141592653589793
@@ -55,6 +53,4 @@
 extern void transform_rotate(transform_t *, double);
 
-extern bool transform_is_fast(transform_t *);
-
 extern void transform_apply_linear(const transform_t *, double *, double *);
 extern void transform_apply_affine(const transform_t *, double *, double *);
Index: uspace/lib/usb/include/usb/hc.h
===================================================================
--- uspace/lib/usb/include/usb/hc.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/usb/include/usb/hc.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -39,5 +39,5 @@
 #include <devman.h>
 #include <ddf/driver.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <fibril_synch.h>
 #include <usb/usb.h>
Index: uspace/lib/usb/include/usb/usb.h
===================================================================
--- uspace/lib/usb/include/usb/usb.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/usb/include/usb/usb.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -35,5 +35,5 @@
 #define LIBUSB_USB_H_
 
-#include <stdbool.h>
+#include <bool.h>
 #include <sys/types.h>
 #include <byteorder.h>
Index: uspace/lib/usbdev/include/usb/dev/request.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/request.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/usbdev/include/usb/dev/request.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -93,8 +93,8 @@
 	uint8_t request;
 	/** Main parameter to the request. */
-	union __attribute__ ((packed)) {
+	union {
 		uint16_t value;
 		/* FIXME: add #ifdefs according to host endianness */
-		struct __attribute__ ((packed)) {
+		struct {
 			uint8_t value_low;
 			uint8_t value_high;
@@ -108,6 +108,4 @@
 	uint16_t length;
 } __attribute__ ((packed)) usb_device_request_setup_packet_t;
-
-int assert[(sizeof(usb_device_request_setup_packet_t) == 8) ? 1: -1];
 
 int usb_control_request_set(usb_pipe_t *,
Index: uspace/lib/usbdev/src/dp.c
===================================================================
--- uspace/lib/usbdev/src/dp.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/usbdev/src/dp.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -45,5 +45,5 @@
 #include <errno.h>
 #include <assert.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <usb/dev/dp.h>
 #include <usb/descriptor.h>
Index: uspace/lib/usbhost/include/usb/host/endpoint.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/endpoint.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/usbhost/include/usb/host/endpoint.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
 #define LIBUSBHOST_HOST_ENDPOINT_H
 
-#include <stdbool.h>
+#include <bool.h>
 #include <adt/list.h>
 #include <fibril_synch.h>
Index: uspace/lib/usbhost/src/usb_endpoint_manager.c
===================================================================
--- uspace/lib/usbhost/src/usb_endpoint_manager.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/usbhost/src/usb_endpoint_manager.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -33,5 +33,5 @@
  */
 
-#include <stdbool.h>
+#include <bool.h>
 #include <assert.h>
 #include <errno.h>
Index: uspace/lib/usbvirt/include/usbvirt/ipc.h
===================================================================
--- uspace/lib/usbvirt/include/usbvirt/ipc.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/lib/usbvirt/include/usbvirt/ipc.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -39,5 +39,5 @@
 #include <ipc/common.h>
 #include <usb/usb.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <usbvirt/device.h>
 #include <async.h>
Index: uspace/srv/bd/ata_bd/ata_bd.c
===================================================================
--- uspace/srv/bd/ata_bd/ata_bd.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/bd/ata_bd/ata_bd.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -49,4 +49,5 @@
 
 #include <stdio.h>
+#include <libarch/ddi.h>
 #include <ddi.h>
 #include <async.h>
@@ -60,5 +61,5 @@
 #include <inttypes.h>
 #include <errno.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <byteorder.h>
 #include <task.h>
Index: uspace/srv/bd/file_bd/file_bd.c
===================================================================
--- uspace/srv/bd/file_bd/file_bd.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/bd/file_bd/file_bd.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -49,5 +49,5 @@
 #include <sys/typefmt.h>
 #include <errno.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <task.h>
 #include <macros.h>
Index: uspace/srv/bd/gxe_bd/gxe_bd.c
===================================================================
--- uspace/srv/bd/gxe_bd/gxe_bd.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/bd/gxe_bd/gxe_bd.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,4 +37,5 @@
 
 #include <stdio.h>
+#include <libarch/ddi.h>
 #include <ddi.h>
 #include <async.h>
Index: uspace/srv/bd/part/guid_part/guid_part.c
===================================================================
--- uspace/srv/bd/part/guid_part/guid_part.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/bd/part/guid_part/guid_part.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -58,5 +58,5 @@
 #include <loc.h>
 #include <errno.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <byteorder.h>
 #include <assert.h>
Index: uspace/srv/bd/part/mbr_part/mbr_part.c
===================================================================
--- uspace/srv/bd/part/mbr_part/mbr_part.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/bd/part/mbr_part/mbr_part.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -67,5 +67,5 @@
 #include <block.h>
 #include <errno.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <byteorder.h>
 #include <assert.h>
Index: uspace/srv/bd/rd/rd.c
===================================================================
--- uspace/srv/bd/rd/rd.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/bd/rd/rd.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -46,5 +46,5 @@
 #include <ddi.h>
 #include <align.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <errno.h>
 #include <async.h>
Index: uspace/srv/clipboard/clipboard.c
===================================================================
--- uspace/srv/clipboard/clipboard.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/clipboard/clipboard.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -28,5 +28,5 @@
 
 #include <stdio.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <async.h>
 #include <ns.h>
Index: uspace/srv/devman/devman.h
===================================================================
--- uspace/srv/devman/devman.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/devman/devman.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
 
 #include <assert.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <dirent.h>
 #include <str.h>
Index: uspace/srv/devman/main.c
===================================================================
--- uspace/srv/devman/main.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/devman/main.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -44,5 +44,5 @@
 #include <errno.h>
 #include <str_error.h>
-#include <stdbool.h>
+#include <bool.h>
 #include <fibril_synch.h>
 #include <stdlib.h>
Index: uspace/srv/fs/cdfs/cdfs_ops.c
===================================================================
--- uspace/srv/fs/cdfs/cdfs_ops.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/fs/cdfs/cdfs_ops.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,5 +38,5 @@
 
 #include "cdfs_ops.h"
-#include <stdbool.h>
+#include <bool.h>
 #include <adt/hash_table.h>
 #include <adt/hash.h>
Index: uspace/srv/fs/cdfs/cdfs_ops.h
===================================================================
--- uspace/srv/fs/cdfs/cdfs_ops.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/fs/cdfs/cdfs_ops.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -34,5 +34,5 @@
 #define CDFS_CDFS_OPS_H_
 
-#include <stdbool.h>
+#include <bool.h>
 
 extern bool cdfs_init(void);
Index: uspace/srv/fs/exfat/exfat.h
===================================================================
--- uspace/srv/fs/exfat/exfat.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/fs/exfat/exfat.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -40,5 +40,5 @@
 #include <atomic.h>
 #include <sys/types.h>
-#include <stdbool.h>
+#include <bool.h>
 #include "../../vfs/vfs.h"
 
Index: uspace/srv/fs/exfat/exfat_dentry.h
===================================================================
--- uspace/srv/fs/exfat/exfat_dentry.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ uspace/srv/fs/exfat/exfat_dentry.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -35,5 +35,5 @@
 
 #include <stdint.h>
-#include <stdbool.h>
+#include <bool.h>
 
 #define EXFAT_FILENAME_LEN	255
Index: uspace/srv/fs/ext2fs/Makefile
===================================================================
--- uspace/srv/fs/ext2fs/Makefile	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
+++ uspace/srv/fs/ext2fs/Makefile	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -0,0 +1,40 @@
+#
+# Copyright (c) 2005 Martin Decky
+# Copyright (c) 2007 Jakub Jermar
+# Copyright (c) 2010 Martin Sucha
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../../..
+LIBS = $(LIBBLOCK_PREFIX)/libblock.a $(LIBFS_PREFIX)/libfs.a $(LIBEXT2_PREFIX)/libext2.a
+EXTRA_CFLAGS += -I$(LIBBLOCK_PREFIX) -I$(LIBFS_PREFIX) -I$(LIBEXT2_PREFIX)
+BINARY = ext2fs
+
+SOURCES = \
+	ext2fs.c \
+	ext2fs_ops.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/srv/fs/ext2fs/ext2fs.c
===================================================================
--- uspace/srv/fs/ext2fs/ext2fs.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
+++ uspace/srv/fs/ext2fs/ext2fs.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -0,0 +1,99 @@
+/*
+ * Copyright (c) 2006 Martin Decky
+ * Copyright (c) 2011 Martin Sucha
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup fs
+ * @{
+ */ 
+
+/**
+ * @file	ext2.c
+ * @brief	EXT2 file system driver for HelenOS.
+ */
+
+#include "ext2fs.h"
+#include <ipc/services.h>
+#include <ns.h>
+#include <async.h>
+#include <errno.h>
+#include <unistd.h>
+#include <task.h>
+#include <stdio.h>
+#include <libfs.h>
+#include "../../vfs/vfs.h"
+
+#define NAME	"ext2fs"
+
+vfs_info_t ext2fs_vfs_info = {
+	.name = NAME,
+	.instance = 0,
+};
+
+int main(int argc, char **argv)
+{
+	printf(NAME ": HelenOS EXT2 file system server\n");
+
+	if (argc == 3) {
+		if (!str_cmp(argv[1], "--instance"))
+			ext2fs_vfs_info.instance = strtol(argv[2], NULL, 10);
+		else {
+			printf(NAME " Unrecognized parameters");
+			return -1;
+		}
+	}
+	
+	async_sess_t *vfs_sess = service_connect_blocking(EXCHANGE_SERIALIZE,
+	    SERVICE_VFS, 0, 0);
+	if (!vfs_sess) {
+		printf(NAME ": failed to connect to VFS\n");
+		return -1;
+	}
+
+	int rc = ext2fs_global_init();
+	if (rc != EOK) {
+		printf(NAME ": Failed global initialization\n");
+		return 1;
+	}	
+		
+	rc = fs_register(vfs_sess, &ext2fs_vfs_info, &ext2fs_ops,
+	    &ext2fs_libfs_ops);
+	if (rc != EOK) {
+		fprintf(stdout, NAME ": Failed to register fs (%d)\n", rc);
+		return 1;
+	}
+	
+	printf(NAME ": Accepting connections\n");
+	task_retval(0);
+	async_manager();
+	/* not reached */
+	return 0;
+}
+
+/**
+ * @}
+ */ 
Index: uspace/srv/fs/ext2fs/ext2fs.h
===================================================================
--- uspace/srv/fs/ext2fs/ext2fs.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
+++ uspace/srv/fs/ext2fs/ext2fs.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -0,0 +1,52 @@
+/*
+ * Copyright (c) 2011 Martin Sucha
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup fs
+ * @{
+ */ 
+
+#ifndef EXT2FS_EXT2FS_H_
+#define EXT2FS_EXT2FS_H_
+
+#include <libext2.h>
+#include <libfs.h>
+#include <sys/types.h>
+
+#define min(a, b)		((a) < (b) ? (a) : (b))
+
+extern vfs_out_ops_t ext2fs_ops;
+extern libfs_ops_t ext2fs_libfs_ops;
+
+extern int ext2fs_global_init(void);
+extern int ext2fs_global_fini(void);
+
+#endif
+
+/**
+ * @}
+ */
